#ifndef _SAM5_USART_DRIVER_H_
#define _SAM5_USART_DRIVER_H_

#include "hardware_defines.h"
#include <stdint.h>
#include <peripheral_clk_config.h>

#define USART_BAUD_RATE 115200
#define USART_TRANSMIT_BUFFER_SIZE 2 * 1024

#ifndef USART_CONSOLE_SERCOM_UNIT
#error "USART_CONSOLE_SERCOM_UNIT is undefined"
#endif
#ifndef USART_CONSOLE_RX_PIN
#error "USART_CONSOLE_RX_PIN is undefined"
#endif
#ifndef USART_CONSOLE_RX_PIN_FUNCTION
#error "USART_CONSOLE_RX_PIN_FUNCTION is undefined"
#endif
#ifndef USART_CONSOLE_TX_PIN
#error "USART_CONSOLE_TX_PIN is undefined"
#endif
#ifndef USART_CONSOLE_TX_PIN_FUNCTION
#error "USART_CONSOLE_TX_PIN_FUNCTION is undefined"
#endif
#ifndef USART_CONSOLE_GLCK_CORE_GEN
#error "USART_CONSOLE_GLCK_CORE_GEN is undefined"
#endif

#define USART_INSERT_SERCOM_UNIT_(pre, unit, post)	pre ## unit ## post									///< This is necessary for C preprocessor macro expansion
#define USART_INSERT_SERCOM_UNIT(pre, unit, post)	USART_INSERT_SERCOM_UNIT_(pre, unit, post)	///< This is necessary for C preprocessor macro expansion

/**
* Some macros to generate "#define USART_SERCOM SERCOMn" out of "#define USART_CONSOLE_SERCOM_UNIT n"
*/
#define USART_SERCOM USART_INSERT_SERCOM_UNIT(SERCOM, USART_CONSOLE_SERCOM_UNIT,)

/**
* Some macros to generate "#define USART_SERCOM hri_mclk_set_APBXMASK_SERCOMn_bit" out of "#define USART_CONSOLE_SERCOM_UNIT n"
*/
#if USART_CONSOLE_SERCOM_UNIT == 0 || USART_CONSOLE_SERCOM_UNIT == 1
#define USART_APB_MCLK_MASK_SETTER USART_INSERT_SERCOM_UNIT(hri_mclk_set_APBAMASK_SERCOM, USART_CONSOLE_SERCOM_UNIT, _bit)		///< SERCOM Unit on APBA Bus
#elif USART_CONSOLE_SERCOM_UNIT == 2 || USART_CONSOLE_SERCOM_UNIT == 3
#define USART_APB_MCLK_MASK_SETTER USART_INSERT_SERCOM_UNIT(hri_mclk_set_APBBMASK_SERCOM, USART_CONSOLE_SERCOM_UNIT, _bit)		///< SERCOM Unit on APBB Bus
#elif USART_CONSOLE_SERCOM_UNIT == 4 || USART_CONSOLE_SERCOM_UNIT == 5 || USART_CONSOLE_SERCOM_UNIT == 6 || USART_CONSOLE_SERCOM_UNIT == 7
#define USART_APB_MCLK_MASK_SETTER USART_INSERT_SERCOM_UNIT(hri_mclk_set_APBDMASK_SERCOM, USART_CONSOLE_SERCOM_UNIT, _bit)		///< SERCOM Unit on APBD Bus
#else
#error "Unknown USART_CONSOLE_SERCOM_UNIT, it is not within [0..7]"
#endif

/**
* Some macros to generate more information out of "#define USART_CONSOLE_SERCOM_UNIT n"
*/
#define USART_SERCOM_GCLK_ID_CORE USART_INSERT_SERCOM_UNIT(SERCOM, USART_CONSOLE_SERCOM_UNIT,_GCLK_ID_CORE)
#define USART_SERCOM_GCLK_ID_SLOW USART_INSERT_SERCOM_UNIT(SERCOM, USART_CONSOLE_SERCOM_UNIT,_GCLK_ID_SLOW)

#define USART_DRE_HANDLER		USART_INSERT_SERCOM_UNIT(SERCOM, USART_CONSOLE_SERCOM_UNIT, _0_Handler)
#define USART_DRE_IRQn			USART_INSERT_SERCOM_UNIT(SERCOM, USART_CONSOLE_SERCOM_UNIT, _0_IRQn)
#define USART_TXC_HANDLER		USART_INSERT_SERCOM_UNIT(SERCOM, USART_CONSOLE_SERCOM_UNIT, _1_Handler)
#define USART_TXC_IRQn			USART_INSERT_SERCOM_UNIT(SERCOM, USART_CONSOLE_SERCOM_UNIT, _1_IRQn)
#define USART_RXC_HANDLER		USART_INSERT_SERCOM_UNIT(SERCOM, USART_CONSOLE_SERCOM_UNIT, _2_Handler)
#define USART_RXC_IRQn			USART_INSERT_SERCOM_UNIT(SERCOM, USART_CONSOLE_SERCOM_UNIT, _2_IRQn)
#define USART_ERROR_HANDLER		USART_INSERT_SERCOM_UNIT(SERCOM, USART_CONSOLE_SERCOM_UNIT, _3_Handler)
#define USART_ERROR_IRQn		USART_INSERT_SERCOM_UNIT(SERCOM, USART_CONSOLE_SERCOM_UNIT, _3_IRQn)

/**
* Calculate the Baud Rate
*/
#define USART_BAUD 65536 - (32768 * (USART_BAUD_RATE / 10) + (CONF_CPU_FREQUENCY / 640)) / (CONF_CPU_FREQUENCY / 320)

void usart_driver_init();
void usart_driver_enable();

void send_bytes(const uint8_t* buf, uint32_t count);
void set_receive_callback(void (*receive_callback)(char));


#endif // _SAM5_USART_DRIVER_H_